from dune.perftool.generation import (backend,
                                      domain)
from dune.perftool.pdelab.geometry import world_dimension
from dune.perftool.pdelab.spaces import name_leaf_lfs


@backend(interface="lfs_inames", name="blockstructured")
def lfs_inames(element, restriction, count=None, context=''):
    assert not ((context == '') and (count is None))
    if count is not None:
        if context != '':
            context = "{}_{}".format(count, context)
        else:
            context = str(count)

    lfs = name_leaf_lfs(element, restriction)

    name = "micro_{}_{}_index".format(lfs, context)
    domain(name, pow(element.degree() + 1, world_dimension()))

    return (name, )
